/*
 * Code for receiving pixel data from GB Camera
 * and mapping it on the screen
 * 1/3/2009
 * Asım Demirağ & Emrah Ali Pekdemir
 */

import processing.serial.*;

int[] GB_Pixels = new int[16384];
Serial GB_Serial; 
int xpos = 64;
int ypos = 64;
int cntr = 0;
color Bkg_Box = color(0);
boolean setm = false;

void setup()
{
  size(128,128);
  background(Bkg_Box);
  noStroke();
  //rect(64,64,128,128);
  PFont GB_Font = createFont(PFont.list()[1], 10, true);
  textFont(GB_Font);
  String portName = Serial.list()[0];
  GB_Serial = new Serial(this, portName,115200);
  noLoop();
}

void draw() 
{
  println("Painting...");
  int index = 0;  
  float brightestValue = 200;
  int brightestX = 0; // X-coordinate of the brightest video pixel
  int brightestY = 0; // Y-coordinate of the brightest video pixel
  int pixelValue;

  for(ypos=0;ypos<123;ypos++)
  {
    for(xpos=0;xpos<128;xpos++)
    {
      //fill((int)map(GB_Pixels[index],144,240,0,255));
      //rect(xpos,ypos,5,5);
      //ellipse(xpos,ypos,2,2);
      if(setm)
      {
        set(xpos,ypos,color((int)map(GB_Pixels[index],144,247,0,255)));
        text("Pixels mapped...",5, 120);
      }
      else
      {
        set(xpos,ypos,color(GB_Pixels[index])); 
        text("Pixels not mapped...",5, 120);
      }
      
      if(setm)
        pixelValue = color((int)map(GB_Pixels[index],144,247,0,255));
      else
        pixelValue = color(GB_Pixels[index]);
    
      float pixelBrightness = brightness(pixelValue);
      // If that value is brighter than threshold, then store the
      // brightness of that pixel, as well as its (x,y) location
      if (pixelBrightness > brightestValue) 
      {
        brightestValue = pixelBrightness;
        brightestY = ypos;
        brightestX = xpos;
        fill(255,0, 0, 64);
        ellipse(xpos-5, ypos-5, 15, 15);
      }     
      index++;
    }
  }

  fill(0,255,0, 128);

  text("Brightest X: "+brightestX, 5, 15);
  text("Brightest Y: "+brightestY, 5, 27);
  redrawing = false;
  saveFrame("frame_####.png");
}

boolean redrawing = false;

void serialEvent(Serial GB_Serial)
{
  if(redrawing) return;
  
  int read;

  read = GB_Serial.read();
  //print(cntr+"-"+read+",");

  if(read == 255){
    cntr = 0;
    redrawing = true;
    redraw();
  }
  else{

    GB_Pixels[cntr] = read;
    //print(cntr+"-"+read+",");
    cntr++;
  }
}

void mousePressed()
{
  GB_Serial.write('a');
}

void keyPressed()
{
  setm ^= true;
}

