/*
 * Code for receiving pixel data from GB Camera & 3D mapping of the image
 * and mapping it on the screen
 * 1/5/2009
 * Asım Demirağ & Emrah Ali Pekdemir
 */

import processing.serial.*;
import processing.opengl.*;

int[] GB_Pixels = new int[16384];
Serial GB_Serial; 
int xpos = 0;
int ypos = 0;
int cntr = 0;
float a = 0.0;

void setup()
{
  size(256, 256, OPENGL);
  PFont GB_Font = createFont(PFont.list()[5], 24, true);
  textFont(GB_Font);
  String portName = Serial.list()[0];
  GB_Serial = new Serial(this, portName,115200);
  noStroke();
  smooth(); 
  noLoop();
}

void draw() 
{
  println("Painting...");
  int index = 0;  
  background(0);
  lights();
   a += 0.1;
  if(a > TWO_PI) { 
    a = 0.0; 
  }
  
//  translate(width/4, height/4);
//  rotateX(0.3);
 // rotateY(0.3);
  
//  pushMatrix();
//  fill(0,255,0,128);
//  noStroke();
//  rotateY(a*5);
//  rotateX(a*5);
//  translate(a*50,50,a*50);
//  sphere(20);   
//  popMatrix();
//   
//  pushMatrix();
//  fill(255,0,0,128);
//  noStroke();
//  translate(a*20,10,a*50);
//  text("TECHNOSHAMAN 2009", 0.5,0.5,a);
//  popMatrix();
   
   
  for(ypos=0;ypos<246;ypos+=2)
  {
    for(xpos=0;xpos<256;xpos+=2)
    {
      pushMatrix();
      fill(color((int)map(GB_Pixels[index],144,247,0,255)));
      translate(xpos, ypos, (int)map(GB_Pixels[index],144,247,0,255)); 
      rotateX(norm(xpos,1.0,-1.0));
      box(2);
      popMatrix();
      index++;
    }
  }


  redrawing = false;
  saveFrame("frame_####.png");
}

boolean redrawing = false;

void serialEvent(Serial GB_Serial)
{
  int read;

  if(redrawing) return;
  read = GB_Serial.read();

  if(read == 255){
    cntr = 0;
    redrawing = true;
    redraw();
  }
  else{

    GB_Pixels[cntr] = read;
    cntr++;
  }
}

void mousePressed()
{
  GB_Serial.write('a');
}

